unit ProtocolEditDlgs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CheckLst, WDosEpcs;

const
  ProtocolDefault = $3FFFFFFF;
  SlavesDefault = 30;

type
  TProtocolEditDlg = class(TForm)
    btnOk: TButton;
    Button2: TButton;
    CheckListBox1: TCheckListBox;
    procedure FormCreate(Sender: TObject);
    procedure CheckListBox1ClickCheck(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
  private
    { Private-Deklarationen }
    FSlaves: Integer;
    FProtocol: TProtocolLength;
    procedure SetProtocol(const Value: TProtocolLength);
    procedure SetSlaves(const Value: Integer);
    procedure FormatStation(Station: Integer; Protocol: Boolean);
  public
    { Public-Deklarationen }
    property Slaves: Integer read FSlaves write SetSlaves;
    property Protocol: TProtocolLength read FProtocol write SetProtocol;
  end;

var
  ProtocolEditDlg: TProtocolEditDlg;

implementation

{$R *.DFM}

const
  ProtocolType: array[Boolean] of string =('kurz', 'lang');

procedure TProtocolEditDlg.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  for I :=2 to 31 do CheckListBox1.Items.Add('');
  Protocol :=ProtocolDefault;
  Slaves :=SlavesDefault;
end;

procedure TProtocolEditDlg.CheckListBox1ClickCheck(Sender: TObject);
var
  Index: Integer;
  Checked: Boolean;
begin
  Index :=CheckListBox1.ItemIndex;
  Checked :=CheckListBox1.Checked[Index];
  FormatStation(Index +2, Checked);
end;

procedure TProtocolEditDlg.SetProtocol(const Value: TProtocolLength);
var
  Station: Integer;
  BitMask: LongWord;
  Protocol: Boolean;
begin
  if FProtocol <>Value then
  begin
    FProtocol := Value;
    BitMask :=1;
    for Station :=2 to 31 do
    begin
      Protocol :=FProtocol and Bitmask <>0;
      FormatStation(Station, Protocol);
      BitMask :=Bitmask shl 1;
    end;
  end;
end;

procedure TProtocolEditDlg.SetSlaves(const Value: Integer);
var
  I: Integer;
begin
  if FSlaves <>Value then
  begin
    FSlaves := Value;
    for I :=2 to 31 do
      CheckListBox1.ItemEnabled[I -2] :=I <=FSlaves +1;
  end;
end;

procedure TProtocolEditDlg.FormatStation(Station: Integer;
  Protocol: Boolean);
begin
  CheckListBox1.Items[Station -2] :=
        Format('Station %0.2d (%s)', [Station, ProtocolType[Protocol]]);
  CheckListBox1.Checked[Station -2] :=Protocol;
end;

procedure TProtocolEditDlg.btnOkClick(Sender: TObject);
var
  Station: Integer;
  BitMask: LongWord;
begin
  FProtocol :=0;
  BitMask :=1;
  for Station :=2 to 31 do
  begin
    if CheckListBox1.Checked[Station -2] then
    FProtocol :=FProtocol or BitMask;
    BitMask :=BitMask shl 1;
  end;
end;

end.
